routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



//Auth::routes(['verify' => false,'register' => false]);

Route::get('/', function(){
	return redirect('login');
})->where(['url' => '|home'])->name('home');

if(env('API_URL')=="" || env('API_URL')==url('/')){
	Auth::routes(['register'=>false]);
	Route::get('index', 'HomeController@index')->name('index');
}

Route::group(['middleware' => ['frontend']], function(){	
	Route::get('/{url?}', 'HomeController@index')->where(['url' => '|home'])->name('home');
});

Route::group(['middleware' => ['auth']], function(){
	Route::get('access-denied', function(){
		return view('access-denied');
	})->name('access-denied');
        Route::resource('profile', 'ProfileController')->only(['index', 'store']);
		Route::group(['middleware' => ['check_permission'],'namespace'=>'Admin','prefix'=>'admin', 'as' => 'admin.'], function(){	

		Route::get('dashboard', 'DashboardController@index')->name('dashboard');
		Route::resource('profile', 'ProfileController')->only(['index', 'store']);
        Route::resource('settings', 'SettingsController')->only(['index', 'store']);

		// For Users
		Route::resources([
			'users' => 'UsersController',
		]);
		
        Route::post('users/getUsers', 'UsersController@getUsers')->name('users.getUsers');
		Route::get('users/status/{user_id}', 'UsersController@status')->name('users.status');	

       // For complainttype
		Route::resource('complainttype', 'ComplaintTypeController')->except(['show']);
		Route::post('complainttype/list', 'ComplaintTypeController@getComplaintType')->name('complainttype.getComplaintType');
		Route::get('complainttype/status/{id}', 'ComplaintTypeController@status')->name('complainttype.status');	

         // For roles
		Route::resource('roles','RoleController');
		Route::get('roles/destroy/{id}', 'RoleController@destroy')->name('roles.destroy');
		Route::get('roles/status/{id}', 'RoleController@status')->name('roles.status');
	
        // For Complaints
		Route::resource('complaints', 'ComplaintsController');
		Route::post('complaints/list', 'ComplaintsController@getComplaints')->name('complaints.getComplaints');
		Route::get('complaints/status/{id}', 'ComplaintsController@status')->name('complaints.status');
		Route::get('complaints/aprovelstatus/{id}', 'ComplaintsController@aprovelStatus')->name('complaints.aprovelstatus');	
		Route::get('complaints/rejectstatus/{id}', 'ComplaintsController@rejectStatus')->name('complaints.rejectStatus');	


		Route::resource('components','ComponentController');
    	Route::get('components/destroy/{id}', 'ComponentController@destroy')->name('components.destroy');
    	Route::get('components/status/{id}', 'ComponentController@status')->name('components.status');

    	Route::resource('vehicles','VehiclesController');
    	Route::post('vehicles/getVehicles', 'VehiclesController@getVehicles')->name('vehicles.getVehicles');
    	Route::get('vehicles/status/{id}', 'VehiclesController@status')->name('vehicles.status');

	});

});

app/Http/Controllers/Admin/ComponentController.php
<?php

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use Spatie\Permission\Models\Permission;
use App\Http\Controllers\Controller;


class ComponentController extends Controller
{ 
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    function __construct()
    {
         $this->middleware('permission:components');
         $this->middleware('permission:component-create', ['only' => ['create','store']]);
         $this->middleware('permission:component-edit', ['only' => ['edit','update']]);
         $this->middleware('permission:component-delete', ['only' => ['destroy']]);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $components = Permission::all();
        return view('admin.component.index',compact('components'));
           
        
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.component.create');
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate([
            'name' => 'required|unique:'.with(new Permission)->getTable(),
        ]);

        Permission::create($request->all());
        
        return redirect()->route('admin.components.index')
                        ->with('success','Component created successfully.');
    }


    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Permission $permission)
    {
        return view('admin.component.show',compact('permission'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {   
        $component = Permission::find($id);
        return view('admin.component.edit',compact('component'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,$id)
    {  
        request()->validate([
            'name' => 'required',
        ]);
        $Permission = Permission::find($id);
        $input=$request->all();
        $Permission->update($input);
        return redirect()->route('admin.components.index')
                        ->with('success','Component updated successfully');
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request,$id)
    {
        Permission::find($id)->delete();
        return redirect()->route('admin.components.index')
                        ->with('success','Component deleted successfully');
    }

     /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function status($id)
    {   
        $permission = Permission::find($id);
        if($permission->is_active==TRUE){
            $input['is_active'] = FALSE;
            $permission->update($input);
        }else{
            $input['is_active'] = TRUE;
            $permission->update($input);
        }
        return redirect()->route('admin.components.index')
                        ->with('success','Status updated successfully');
    }
    
}

resources/views/admin/component/create.blade.php
@extends('admin.layouts.valex_app')
@section('content')
<div class="container"> 
    <!-- Page Heading -->
    <div class="breadcrumb-header justify-content-between">
        <div class="left-content">
            <div>
              <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Components</h2>
            </div>
        </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
           
              <div class="card">
              
                <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">Add Component</h6>
                </div>
                <div class="card-body ">
                    <form action="{{ route('admin.components.store') }}" method="POST" id="frmcomponent">
                    @csrf
                    <div class="row">
                      <label class="col-sm-2 col-form-label">Name <span style="color:red">*</span></label>
                      <div class="col-sm-7">

                        <div class="form-group {{$errors->has('name') ? config('constants.ERROR_FORM_GROUP_CLASS') : ''}}">
                        {!! Form::text('name', null, array('placeholder' => 'Name','class' => 'form-control')) !!}
                        @if($errors->has('name'))
                         <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('name') }}</span>
                        @endif
                        </div>
                      </div>
                    </div>
                  
                  </div>
                    <div class="card-footer">
                    <button type="submit" class="btn btn-responsive btn-primary">Submit</button>
                    <a href="{{route('admin.components.index')}}"  class="btn btn-responsive btn-secondary">Cancel</a>
                  </div>
                  </form>
                </div>
              </div>
           </div>
         </div>
      </div>
     </div>
@endsection
@section('admin_scipts')
<script type="text/javascript" src="{{ asset('js/jquery-validation/dist/jquery.validate.min.js') }}"></script>
<script type="text/javascript">
$(document).ready(function(){
    $('#frmcomponent').validate({
        rules: {
            name: {
                required: true
            },
            
        },
    });
})
</script>
@endsection

resources/views/admin/component/edit.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/select2/css/select2.min.css') }}" rel="stylesheet">
@endsection
@section('content')
<div class="container"> 
    <!-- Page Heading -->
    <div class="breadcrumb-header justify-content-between">
        <div class="left-content">
            <div>
              <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Customers</h2>
            </div>
        </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
           {!! Form::model($component, ['method' => 'PATCH','files'=>true,'route' => ['admin.components.update', $component->id],'id'=>'frmuser']) !!}
              <div class="card ">
              <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">Edit Component</h6>
                </div>
              <div class="card-body ">
                <div class="row">
                  <label class="col-sm-2 col-form-label">Name <span style="color:red">*</span></label>
                  <div class="col-sm-7">

                    <div class="form-group {{$errors->has('name') ? config('constants.ERROR_FORM_GROUP_CLASS') : ''}}">
                  <input type="text" name="name" value="{{ $component->name }}" class="form-control" placeholder="Name">
                    @if($errors->has('name'))
                     <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('name') }}</span>
                    @endif
                    </div>
                  </div>
                </div>
               </div>
               <div class="card-footer">
                    <button type="submit" class="btn btn-responsive btn-primary">Submit</button>
                    <a href="{{route('admin.components.index')}}"  class="btn btn-responsive btn-secondary">Cancel</a>
                </div>
              </form>
            </div>
            {!! Form::close() !!}
          </div>
        </div>
        </div>
      </div>
     </div>
@endsection
@section('admin_scipts')
<script type="text/javascript" src="{{ asset('js/jquery-validation/dist/jquery.validate.min.js') }}"></script>
<script type="text/javascript">
$(document).ready(function(){
    $('#frmcomponent').validate({
        rules: {
            name: {
                required: true
            },
            
        },
    });
})
</script>
@endsection

resources/views/admin/component/index.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/datatable/css/dataTables.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/jquery.dataTables.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.dataTables.min.css')}}" rel="stylesheet">
@endsection
@section('content')
<div class="container">
    <!-- Content Row -->
    <div class="breadcrumb-header justify-content-between">
        <div class="left-content">
            <div>
                <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Components</h2>
            </div>
        </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
    <div class="card">
        <div class="card-header py-3 cstm_hdr">
            <h6 class="m-0 font-weight-bold text-primary">Components</h6>       
            <a href="{{ route('admin.components.create') }}" class="btn btn-sm btn-icon-split float-right btn-outline-warning">
                <span class="icon text-white-50">
                    <i class="fas fa-plus"></i>
                </span>
                <span class="text">Add Component </span>
            </a>
        </div>
        <div class="card-body">       
          <div class="table-responsive">
                <table class="table table-bordered" width="100%" cellspacing="0" id="components">
                    <thead>
                        <tr>                            
                            <th>Name</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($components as $component)
                        <tr>
                            <td>{{ $component->name }}</td>
                            <td class="center">
                            <a href="javascript:void(0)"> <span class="badge badge-success">Active</span> </a></td>
                            <td>
                             <a href="{{route('admin.components.edit',[$component->id])}}" class="btn btn-success btn-circle btn-sm" title="edit"><i class="fas fa-edit"></i></a>
                            </td>
                        </tr>
                        @endforeach
                    </tbody>
                    <tfoot>
                        <tr>                            
                            <th>Name</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
    </div>
    </div>
    </div>
</div>
@endsection
@section('scripts')
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.bootstrap4.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/vfs_fonts.js') }}"></script>
<script type="text/javascript">
$(document).ready(function() {
  jQuery('#components').DataTable({
     iDisplayLength:100,
    });
});
</script>
@endsection

resources/views/admin/component/show.blade.php
@extends('layouts.admin')
@section('content')
<div class="container-fluid">
     <h1 class="h3 mb-2 text-gray-800">Products</h1>
    <div class="card shadow mb-4">
        <div class="card-header py-3">
             <h5 class="m-0 font-weight-bold text-primary">Product View</h5>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Name:</strong>
                        {{ $product->name }}
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>Details:</strong>
                        {{ $product->detail }}
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <a class="btn btn-danger" href="{{ route('products.index') }}">Cancel</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection